OpenSSL

Kohteesta Linux.fi
Siirry navigaatioon Siirry hakuun
OpenSSL

Käyttöliittymä kirjasto
Lisenssi Apache, BSD
Kotisivu www.openssl.org
Lähdekoodi Lähdekoodia ei ole määritelty

OpenSSL avoimen lähdekoodin on työkalu SSL v2/v3- ja TLS v1 -protokollien käsittelyyn. Sen avulla on myös mahdollista mm. luoda ja hallita julkisia ja yksityisiä salausavaimia, X.509-sertifikaatteja, laskea tarkistussummia ja käsitellä S/MIME-allekirjoitettuja tai -salattuja sähköposteja. HTTPS-salattu verkkosivusto voidaan toteuttaa OpenSSL:n ja esimerkiksi Apachen avulla. OpenVPN on OpenSSL:n avulla toteutettu, avoin VPN-protokolla.

Tiedostojen salaus[muokkaa]

OpenSSL:n avulla voidaan myös salata tiedostoja. OpenSSL tukee useita algoritmeja, joista yleisin lienee AES.

$ openssl aes-256-cbc -in tiedosto.txt -out salattu_tiedosto.enc

Salatun tiedoston purkaminen:

$ openssl aes-256-cbc -d -in salattu_tiedosto.enc -out tiedosto.txt

Mikäli tiedosto halutaan salata tulostettavaan muotoon, voidaan käyttää valitsinta -a.

Lisätietoa ECB ja CBC moodeista:

Tietoturva[muokkaa]

OpenSSL-kirjastosta on löytynyt historiansa aikana kaksi todella vakavaa tietoturva-aukkoa.

Haavoittuvuus Debianin OpenSSL-paketissa (CVE-2008-0166)[muokkaa]

Vuonna 2006 Debianin kehittäjä lisäsi OpenSSL-kirjastoon patchin, joka rikkoi satunnaislukugeeraattorin (versio 0.9.8c-1). Bugi ehti olla Debianin OpenSSL-kirjastossa kaksi vuotta kunnes se huomattiin ja korjattiin. Tuona aikana generoidut avaimet, sekä salatut tiedostot ovat alttiita brute-force-hyökkäyksille. Tämä haavoittuvuus vaikutti Debianin lisäksi myös kaikkiin siihen pohjautuviin jakeluihin, kuten Ubuntuun.

  • Debian 4.0 Etch, korjaava päivitys 0.9.8c-4etch3
  • Debian 5.0 Lenny, korjaava päivitys 0.9.8g-9

https://www.debian.org/security/2008/dsa-1571

Heartbleed (CVE-2014-0160)[muokkaa]

Pääartikkeli: Heartbleed

Heartbleediksi nimetty haavoittuvuus on 7.4.2014 paljastunut bugi OpenSSL-kirjaston heartbeat-protokollassa. Bugi mahdollistaa palvelimen muistin osittaisen kopioimisen jälkiä jättämättä.

Muut[muokkaa]

Jakelukohtaista[muokkaa]

Fedora, CentOS ja RHEL[muokkaa]

Patenttisyistä Fedora-pohjaisten jakeluiden OpenSSL-paketista on poistettu ECC-algoritmit. Pyynnöistä huolimatta myöskään RPM Fusion ei ole suostunut toimittamaan OpenSSL:n täydellistä versiota. Tämän seurauksena muun muassa osaa bitcoin-asiakasohjelmista ei voida sellaisenaan kääntää Fedoralle. Ongelman voi korjata itse kääntämällä OpenSSL:n alkuperäisistä lähdekoodeista.

Katso myös[muokkaa]

Salausohjelmia
bcrypt | CipherShed | ccrypt | Enigmail | GnuPG | LibreSSL | MCrypt | OpenSSL | Seahorse | Tomb | VeraCrypt